<?php
// $Id: uc_saferpay.pages.inc,v 1.1 2010/02/02 12:20:38 sarhugo Exp $

/**
 * @file
 * Saferpay menu items callbacks.
 */

// Handles a complete saferpay sale.

function uc_saferpay_complete($order) {
  if (intval($_SESSION['cart_order']) != $order->order_id || $order->payment_method != 'saferpay') {
    drupal_goto('cart');
  }
  parse_str($_SERVER['QUERY_STRING'], $input);
  $DATA = rawurldecode($input['DATA']);
  while (drupal_strtolower(drupal_substr($DATA, 0, 14)) == '<idp msgtype=\\') {
    $DATA = stripslashes($DATA);
  }
  $SIGNATURE = rawurldecode($input['SIGNATURE']);
  watchdog('uc_saferpay', 'Receiving Payment Complete Notification. <pre>@debug</pre>',
    array('@debug' =>  variable_get('uc_saferpay_debug', FALSE) ? 'DATA: ' . var_export($DATA, TRUE) . PHP_EOL . 'SIGNATURE: ' . var_export($SIGNATURE, TRUE) : '')
  );

  $tx_amount = 0;
  if (preg_match('/^<idp\s.*amount="([0-9]+)".*>$/i', $DATA, $matches)) {
    $tx_amount = floatval($matches[1]);
  }
  $tx_currency = $currency;
  if (preg_match('/^<idp\s.*currency="([A-Z]{3})".*>$/i', $DATA, $matches)) {
    $tx_currency = $matches[1];
  }
  $payment_provider_id = 0;
  if (preg_match('/^<idp\s.*providerid="([0-9]+)".*>$/i', $DATA, $matches)) {
    $payment_provider_id = intval($matches[1]);
  }
  $payment_provider_name = '';
  if (preg_match('/^<idp\s.*providername="([^"]+)".*>$/i', $DATA, $matches)) {
    $payment_provider_name = $matches[1];
  }
  $url = 'https://www.saferpay.com/hosting/VerifyPayConfirm.asp?DATA=' . drupal_urlencode($DATA) . '&SIGNATURE=' . drupal_urlencode($SIGNATURE);
  $result = _uc_saferpay_process_url($url);
  if (drupal_substr($result, 0, 3) == 'OK:' ) {
    parse_str(drupal_substr($result, 3), $result_output);
    /*
     * Record payment log
     *   $ID = saferpay transaction identifier, store in DBMS
     *   $TOKEN = token of transaction, store in DBMS
     */
    db_query("INSERT INTO {uc_payment_saferpay_tx} (order_id, txn_id, mc_gross, mc_currency, provider_id, provider_name, received) VALUES (%d, '%s', '%s', '%s', '%s', '%s', %d)", $order->order_id, $result_output['ID'], $tx_amount / 100, $tx_currency, $payment_provider_id, $payment_provider_name, time());

    if (variable_get('uc_saferpay_autocomplete', TRUE)) {
        /***** Optional: Finalize payment by capture of transaction *****/
        $url = 'https://www.saferpay.com/hosting/PayComplete.asp?ACCOUNTID=' . variable_get('uc_saferpay_account_id', '99867-94913159&spPassword=XAjc3Kna') . '&ID=' . $result_output['ID'] . '&TOKEN=' . drupal_urlencode($result_output['TOKEN']);
        $result = _uc_saferpay_process_url($url);
        if (drupal_substr($result, 0, 2) == 'OK') {
          /* Record payment on order */
          $context = array(
            'revision' => 'formatted-original',
            'type' => 'amount',
          );
          $options = array(
            'sign' => FALSE,
          );
          $comment = t('Saferpay transaction ID: @txn_id', array('@txn_id' => $result_output['ID']));
          uc_payment_enter($order->order_id, 'saferpay', $tx_amount / 100, $order->uid, NULL, $comment);
          uc_order_comment_save($order->order_id, 0, t('Payment of @amount @currency submitted through Saferpay.', array('@amount' => uc_price($tx_amount / 100, $context, $options), '@currency' => $tx_currency)), 'order', 'payment_received');
          db_query("UPDATE {uc_payment_saferpay_tx} SET completed = 1, complete_result = '%s' WHERE order_id = %d AND txn_id = '%s'", $result, $order->order_id, $result_output['ID']);
        }
        else {
          db_query("UPDATE {uc_payment_saferpay_tx} SET complete_result = '%s' WHERE order_id = %d AND txn_id = '%s'", $result, $order->order_id, $result_output['ID']);
        }
    }
    $_SESSION['do_complete'] = TRUE;
    drupal_goto('cart/checkout/complete');
  }
  else {
    drupal_set_message(t('An error has occurred in your Saferpay payment. Please review your cart and try again.'));
  }
  drupal_goto('cart');
}

// Handles a cancelled saferpay sale.

function uc_saferpay_cancel() {
  unset($_SESSION['cart_order']);
  drupal_set_message(t('Your Saferpay payment was cancelled. Please feel free to continue shopping or contact us for assistance.'));
  drupal_goto('cart');
}